﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: True
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Private rp As RuntimePermissions
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Private lblSendStatus As Label
	Private btnBTConnect As Button
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	Activity.LoadLayout("ManualControl")
End Sub


Sub Activity_Resume	
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

' Searches for BT Devices
Sub SearchForDevices
	Log("Search for devices")
	rp.CheckAndRequest(rp.PERMISSION_ACCESS_COARSE_LOCATION)
	Wait For Activity_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		ToastMessageShow("No permission...", False)
		Return
	End If
	Dim success As Boolean = Starter.Manager.SearchForDevices
	If success = False Then
		ToastMessageShow("Error starting discovery process.", True)
	Else
		ProgressDialogShow2("Searching for devices...", False)
	End If
End Sub

Public Sub DiscoverFinished
	Log("Discovery Finished")
	ProgressDialogHide
	If Starter.Manager.foundDevices.Size = 0 Then
		ToastMessageShow("No device found.", True)
	Else
		Dim l As List
		l.Initialize
		For Each nm As NameAndMac In Starter.Manager.foundDevices
			l.Add(nm.Name)
		Next
		InputListAsync(l, "Choose device to connect", -1, True)
		Wait For InputList_Result (Index As Int)
		If Index <> DialogResponse.CANCEL Then
			Dim device As NameAndMac = Starter.Manager.foundDevices.Get(Index)
			Starter.Manager.ConnectTo(device)
			ProgressDialogShow2($"Trying to connect to: ${device.Name}"$, False)
		End If
	End If
End Sub

Public Sub AfterConnect (Success As Boolean)
	Log("After Connect")
	ProgressDialogHide
End Sub


Sub LoadProfileArray
	For i = 0 To Starter.TotalDays-1
		For j = 0 To Starter.TotalSteps-1
			Starter.Profile(i,j).data1=j
			Starter.Profile(i,j).data2= j+12
			Starter.Profile(i,j).data3=j+10
	Next
	Next
End Sub



Sub SendProfile
	Log("SendProfile")
	LoadProfileArray											'Put some info in for test
	If Starter.BTConnectionState=True Then
		For i=0 To Starter.TotalDays-1
			For j = 0 To Starter.TotalSteps-1
				Starter.SendArray(0) = 2					'Key for this data
				Starter.SendArray(1) = i					'DayCount
				Starter.SendArray(2) = Starter.Profile(i,j).data1	
				Starter.SendArray(3) = Starter.Profile(i,j).data2	
				Starter.SendArray(4) = Starter.Profile(i,j).data3
				Log("i= "&i&"  j="&j)
				CallSub(Starter,"SendToESP32")
			Next
		Next	
	Else
		MsgboxAsync("BT not Connected","Cannot Send")
	End If
End Sub



'=============================================================
'Buttons
'==============================================================

Sub btnSend_Click
	If Starter.BTConnectionState=True Then
		lblSendStatus.Text="Sending Profile... Please Wait"
		SendProfile
	Else
		Msgbox("Not Connected to Bluetooth", "No Connection")
	End If
End Sub



Sub btnBTConnect_Click                     
	If Starter.BTConnectionState=False Then 
		Starter.Manager.ListenForConnections         ' Allos phone to be BT Visible  
		lblSendStatus.Text="Connecting to BT"
		SearchForDevices
	Else
		lblSendStatus.Text="Disconnecting from BT"
		Starter.Manager.Disconnect
	End If
End Sub








