﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'network stuff
	Public serial As Serial
	Public astream As AsyncStreams
	Public Manager As BluetoothManager
	Public BTName As String = "ESP32BT"
	Public BTConnectionState As Boolean=False
	
	Public TotalDays As Int = 7
	Public TotalSteps As Int = 10
	
	Public Profile(TotalDays,TotalSteps) As StepData   ' 10day2, 10 steps per day
	Type StepData(data1 As Int,data2 As Int,data3 As Int)
	
	'Send Array
	Public ProfileArray(7,10) As Int
	Public ser As B4RSerializator
	Public SendArray(8) As Int                   ' Sends via B4R Serial

	
End Sub

Sub Service_Create
	ser.Initialize
	serial.Initialize("serial")
	Manager.Initialize
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub


'Called from successful connection on Bluetooth
Sub BTConnected
	Log("BT Connected")
	If astream.IsInitialized Then astream.Close
	astream.InitializePrefix(serial.InputStream, True, serial.OutputStream, "astream")
	BTConnectionState=True
End Sub


	  
Sub astream_NewData (Buffer() As Byte)
	Dim Data() As Object = ser.ConvertBytesToArray(Buffer)    ' Converts to int
	Log("From ESP32 "& Data(0) & "  "& Data(1) &"  " & Data(2) & "  " & Data(3)&"  "& Data(4))
	
End Sub



Sub Wait(ms As Int)
	Dim n As Long = DateTime.Now + ms
	Do While DateTime.Now < n
	Loop
End Sub

' Sends information to ESP32
Sub SendToESP32
	If BTConnectionState Then
		astream.write(ser.ConvertArrayToBytes(Array(SendArray(0),SendArray(1),SendArray(2),SendArray(3),SendArray(4),SendArray(5),SendArray(6))))
    Wait(5)
	End If
End Sub



Sub astream_Error
	BTConnectionState=False
End Sub

Sub astream_Terminated
End Sub

